//wsserver.h

#ifndef _wsserver_h_
#define _wsserver_h_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>    
#include <time.h>
#include <pthread.h>
#include <signal.h>
#include "config.h"

typedef struct
{
	uint8_t		buffer[_BUFSIZE];
	uint8_t		str_from_buf[_BUFSIZE];
	uint8_t		flagping;
	uint8_t		resp[256];
	uint8_t		masking_key[4];			//
	int		szresp;				//размер ответа
	char		Sec_WebSocket_Key[26];
	int		Sec_WebSocket_Version;
	char		Sec_WebSocket_Extensions[64];
	char		Sec_WebSocket_Accept[64];
} WSDAT;

typedef struct
{
	int			csock;
	uint8_t			idclient;
	uint8_t			midcl[_maxWSsocket];
	uint8_t			cntclient;
	pthread_t       	pth[_maxWSsocket];		//массив потоков
	pthread_attr_t 		tattr[_maxWSsocket];		//массив атрибутов потоков
} WSSERVER;

void				serverWSlisten(void);
void 				server_con(WSSERVER * wss);
extern pthread_mutex_t         	serverWSmutex;
extern uint8_t			work;
extern WSSERVER			wsserver;
extern int			wsport;
extern int			startWSserver(void);


#endif

